#include "sssd.h"
#include "internals.h"

/*
	Return pointer to SSSD's audio buffers
*/

void* sssd_getBuffer(struct sssdaudio *ga)
{
   struct WinPlatformData *pdata;
   void *buffer = 0;
   if (ga) {
		pdata = (struct WinPlatformData *)ga->platformData;
		buffer = pdata->WinBuffer[0];
   }
   return buffer;
}

// send internal wave buffer to device
void sssd_sendBuffer(struct sssdaudio *ga, int bufnum)
{
	struct WinPlatformData *pdata;
	LPWAVEHDR  hdr;
	int i;

	if (ga)	{
		pdata=(struct WinPlatformData *)ga->platformData;
		hdr = &pdata->headers[bufnum];
		hdr->dwFlags &= ~WHDR_DONE;			// clear 'done' bit in header
		// Send to device
		i = waveOutWrite(pdata->hWaveOut, hdr, sizeof(WAVEHDR));
		if(i != MMSYSERR_NOERROR)
			printf("ERROR: waveOutWrite %d\n",i);
	}
}

/*
    Return if a waveout buffer is playing
	Typically used in conjunction with sendBuffer()
*/
int sssd_isBufferPlaying(struct sssdaudio *ga, int bufnum)
{
	if (ga)	{
		struct WinPlatformData *pdata;
		LPWAVEHDR  hdr;
		pdata = (struct WinPlatformData *)ga->platformData;
		hdr = &pdata->headers[bufnum];
		return ((hdr->dwFlags & WHDR_DONE) == 0);
	}
	return 0;
}
