#include <avkon.hrh>
#include <aknnotewrappers.h>

#include "HelloWorld.pan"
#include "HelloWorldAppUi.h"
#include "HelloWorldAppView.h"
#include "HelloWorld.hrh"

// ConstructL is called by the application framework
void CHelloWorldAppUi::ConstructL() {
    BaseConstructL();

    iAppView = CHelloWorldAppView::NewL(ClientRect());

    AddToStackL(iAppView);
}

CHelloWorldAppUi::CHelloWorldAppUi() {
	// no implementation required
}

CHelloWorldAppUi::~CHelloWorldAppUi() {
    if (iAppView) {
        RemoveFromStack(iAppView);
        delete iAppView;
        iAppView = NULL;
    }
}

// handle any menu commands
void CHelloWorldAppUi::HandleCommandL(TInt aCommand) {
    switch(aCommand) {
        case EEikCmdExit:
        case EAknSoftkeyExit:
            Exit();
            break;

        case EPlaySoundCommand:
			iAppView->PlaySound();
            break;

        default:
            Panic(EHelloWorldBasicUi);
            break;
    }
}


void CHelloWorldAppUi::HandleForegroundEventL(TBool aForeground) {
    if (aForeground) {
        if (iAppView) iAppView->Unpause();
        SetKeyBlockMode(ENoKeyBlock);
    } else {
        if (iAppView) iAppView->Pause();
        SetKeyBlockMode(EDefaultBlockMode);
    }
}

